const system = require("../../../system");
// const Dao = require("../../dao.base");
const ServiceBase = require("../../sve.base");
const uuidv4 = require('uuid/v4');
class OrderInfoService extends ServiceBase {
  constructor() {
    super("dbcorder", ServiceBase.getDaoName(OrderInfoService));
    this.flowlogDao = system.getObject("db.dbcorder.flowlogDao");
    this.orderproductDao = system.getObject("db.dbcorder.orderproductDao");
    this.ordercontactsDao = system.getObject("db.dbcorder.ordercontactsDao");
    this.orderReceiptVoucherDao = system.getObject("db.dbcpay.orderreceiptvoucherDao");
    this.moneyJourneyDao = system.getObject("db.dbcpay.moneyjourneyDao");

  }
  //----------------------订单创建-----------start----------------
  async createOrder(pobj, orderNo, t) {
    var actionBody = pobj.actionBody;
    var channelOrder = actionBody.channelOrder;
    var orderContact = actionBody.orderContact;
    var price_item = actionBody.product_info.price_item;
    var totalServiceCharge = Number(price_item.service_charge || 0) * Number(actionBody.quantity || 0);
    var totalPublicExpense = Number(price_item.public_expense || 0) * Number(actionBody.quantity || 0);
    var totalSupplyPrice = Number(price_item.supply_price || 0) * Number(actionBody.quantity || 0);//统计供货价格

    var price_additions_item = actionBody.product_info.price_additions_item;
    if (price_additions_item && actionBody.additions.quantity) {
      totalServiceCharge = totalServiceCharge + Number(price_additions_item.service_charge || 0) * Number(actionBody.additions.quantity || 0);
      totalPublicExpense = totalPublicExpense + Number(price_additions_item.public_expense || 0) * Number(actionBody.additions.quantity || 0);
      totalSupplyPrice = totalSupplyPrice + Number(price_additions_item.supply_price || 0) * Number(actionBody.additions.quantity || 0);//统计供货价格
    }
    var totalProfitSum = Number(actionBody.totalSum) - Number(totalSupplyPrice || 0);//利润
    var pfProfitSum = (100 - Number(price_item.channel_profit_rate || 0)) / 100 * totalProfitSum;
    if (pfProfitSum < 0) {
      pfProfitSum = 0;
    }
    var channelProfitSum = Number(totalProfitSum) - Number(pfProfitSum);
    var payTime = channelOrder.payTime || new Date();
    var params = {
      uapp_id: pobj.appInfo.uapp_id,//int(11)       //                                                                                                                                                                                     
      orderNo: orderNo,//varchar(64)   //订单号                                                                                                                                                                                        
      channelServiceNo: channelOrder.channelServiceNo || orderNo,//varchar(64)   //渠道服务单号                                                                                                                                                                               
      channelOrderNo: channelOrder.channelOrderNo || orderNo,//varchar(1024) //渠道订单号列表，多个以,隔开                                                                                                                                                         
      needNo: channelOrder.needNo || "",//需求号--用于服务商或需求表中创建订单   
      channelUserId: pobj.userInfo.channel_userid,//varchar(64)   //                                                                                                                                                                                                 
      ownerUserId: pobj.userInfo.channel_userid,//varchar(20)   //                                                                                                                                                                                                 
      payTime: channelOrder.orderStatus && channelOrder.orderStatus == 2 ? payTime : null,//datetime      //                                                                                                                                                                                                 
      quantity: actionBody.quantity,//int(11)       //项目订单数量（即服务项目的倍数，默认值为1）                                                                                                                                 
      serviceQuantity: 0,//int(11)       //项目订单交付数量（即与项目订单数量相对应）                                                                                                                                                                                                   
      orderStatus: channelOrder.orderStatus || 1,//int          //订单状态: 1: 待付款, 2: 已付款, 4: 待服务, 8: 已完成
      totalSum: actionBody.totalSum,//decimal(12,2) //订单总额(产品价格×优惠费率×订单件数)                                                                                                                                           
      payTotalSum: actionBody.payTotalSum || actionBody.totalSum,//decimal(12,2) //                                                                                                                                                                                                 
      refundSum: 0,//decimal(12,2) //退款总额
      totalServiceCharge: totalServiceCharge,//decimal(12,2) //服务费总额（产品配置的服务费*订单件数）                                                                                                                                       
      totalPublicExpense: totalPublicExpense,//decimal(12,2) //官费总额（产品配置的官费*订单件数）   
      totalProfitSum: totalProfitSum,//decimal(12,2) //订单毛利润总额（产品价格-供货价格））  
      pfProfitSum: pfProfitSum,//decimal(12,2) //订单平台毛利润总额（(100-渠道利润分成比例)/100 * 订单毛利润总额）                                                                                                         
      channelProfitSum: channelProfitSum,//decimal(12,2) //订单渠道分成毛利润总额(订单毛利润总额-平台毛利润总额)  

      totalDiscounts: 0,//decimal(12,2) //优惠总额（（服务费总额+官费总额）-订单总额(产品价格×优惠费率×订单件数)>0则有优惠额度）暂时没有用到                                                                                                                                                    
      pfSettleProfit: 0,//int(11)       //平台结算渠道利润,0否，1是                                                                                                                                                             
      invoiceApplyStatus: "00",//varchar(10)   //发票状态:00: 未申请, 10: 已申请,20:已开票                                                                                                                                           
      notes: actionBody.notes || "",//varchar(255)  //                                                                                                                                                                                                 
      opNotes: "",//varchar(255)  //操作备注       
    };
    var order = await this.dao.create(params, t);//创建订单
    var orderLog = {
      uapp_id: pobj.appInfo.uapp_id,
      sourceOrderNo: orderNo,
      opContent: "您提交了订单，请及时支付",
      isShow: 1
    };
    await this.flowlogDao.create(orderLog, t);
    if (["zzsbzc"].indexOf(actionBody.product_info.item_code) < 0) {
      delete actionBody.product_info["price_list"];
    }
    var orderProductObj = {
      uapp_id: pobj.appInfo.uapp_id,
      sourceOrderNo: orderNo,   // 来源单号
      productType_id: actionBody.product_info.productType_id,//产品类型Id
      pathCode: actionBody.product_info.path_code,//产品路径
      itemCode: actionBody.product_info.item_code,//产品编码
      itemName: actionBody.product_info.item_name,//产品名称                                               
      channelItemCode: actionBody.product_info.channel_item_code,//  渠道产品编码                                                 
      channelItemName: actionBody.product_info.channel_item_name,//  渠道产品名称 
      channelItemAppendName: actionBody.channelItemAppendName || "",//服务商产品附加名称
      serviceItemCode: actionBody.product_info.service_item_code,//  服务商产品编码
      payAfterJumpUrl: actionBody.product_info.pay_after_jump_url,
      picUrl: actionBody.product_info.pic_url,//  产品图片地址      
      price: actionBody.product_info.price_item.price,//定价
      priceDesc: actionBody.product_info.price_item.price_desc,//定价描述    
      priceTypeName: actionBody.product_info.price_item.price_type_name,//定价类型名称
      quantity: actionBody.quantity,//  订单数量（即产品的倍数，默认值为1）   
      opPayType: "00",//  操作付款类型:00: 创建订单, 10: 补单
      serviceItemSnapshot: JSON.stringify(actionBody.product_info),      //产品快照  
    };
    var orderProduct = await this.orderproductDao.create(orderProductObj, t);//订单产品 
    var orderReceiptVoucherObj = {
      uapp_id: pobj.appInfo.uapp_id,
      sourceOrderNo: orderNo,   // 来源单号
      accountType: "other",
      payDate: payTime,//支付时间
      totalSum: actionBody.payTotalSum || actionBody.totalSum,//订单总额
      auditStatus: "dsh",
      wxPayOrderCode: orderNo,//业务微信支付订单号
      aliPayOrderCode: orderNo,//业务支付宝支付订单号
      busPayOrderCode: orderNo,//业务支付订单号

      // payOrderNo: DataTypes.STRING, //支付凭证流水单号，如：微信支付凭证单号
      // buyerOpenId: DataTypes.STRING,//用户在支付商户appid下的唯一标识或买家在支付宝的用户id
      // passTradeNo: DataTypes.STRING,//通道的统一订单号
      // buyerAliLogonId: DataTypes.STRING,//买家支付宝账号
      // certifyFileUrl: order.orderNo, //支付证明文件Url
    };
    if (channelOrder.orderStatus && channelOrder.orderStatus == 2) {//订单状态: 1: 待付款, 2: 已付款, 4: 待服务, 8: 已完成
      var moneyObj = {
        uapp_id: pobj.appInfo.uapp_id,
        sourceOrderNo: orderNo,   // 来源单号
        channelUserId: pobj.userInfo.channel_userid,
        ownerUserId: pobj.userInfo.channel_userid,
        accountType: "other",//帐户类型（ 支付类型）:"cash": "现金", "bank": "银行" ,"wx":"微信","alipay":"支付宝","other":"其它"
        directionType: "sr",//凭单类型,"sr": "收","zc": "支"
        voucherDate: payTime,//凭单时间
        recvAmount: actionBody.payTotalSum || actionBody.totalSum,//收总额
        sourceType: "orderinfo",//来源类型 "orderinfo": "订单","expensevoucher": "费用单"
        auditStatus: "tg",//审核状态"dsh": "待审核", "btg": "不通过", "tg": "通过"
      };
      var moneyJourney = await this.moneyJourneyDao.create(moneyObj, t);
      orderReceiptVoucherObj.auditStatus = "tg";
    }
    if (orderContact && orderContact.mobile) {
      var customerContactObj = {
        uapp_id: pobj.appInfo.uapp_id,//int(11)       //  
        sourceOrderNo: orderNo,//交付订单号   
        contactName: orderContact.contacts || "",//手机号 
        mobile: orderContact.mobile,//手机号
        email: orderContact.email || ""
      };
      await this.ordercontactsDao.create(customerContactObj, t);
    }//渠道购买存在购买者手机号
    var orderReceiptVoucher = await this.orderReceiptVoucherDao.create(orderReceiptVoucherObj, t);
  }
  /**
   * 创建商标订单
   * @param {*} pobj
   * {
          "actionType": "addOrder",
          "actionBody": {
            "channelItemCode":"zzsbzc",
            "id":1,
            "quantity":1,
            "totalSum":300,
            "channelOrder":null,
            "deliveryData":null
          }
      }
   */
  async createTmOrder(pobj) {
    var packagingTmResult = await this.packagingTmDeliveryData(pobj, pobj.actionBody);
    if (packagingTmResult.status != 0) {
      return packagingTmResult;
    }
    var self = this;
    return await self.db.transaction(async function (t) {
      var orderNo = await self.getBusUid("tm" + pobj.appInfo.uapp_id);
      var item = await self.createOrder(pobj, orderNo, t);
      self.addOrderDelivery(pobj.actionBody.deliveryData, orderNo);
      return system.getResultSuccess({
        orderNo: orderNo,
        channelServiceNo: pobj.actionBody.channelOrder.channelServiceNo || orderNo,
        channelOrderNo: pobj.actionBody.channelOrder.channelOrderNo || orderNo,
        channelParams: pobj.actionBody.channelOrder.channelParams || ""
      });
    });
  }

  async packagingTmDeliveryData(pobj, actionBody) {//重新组装商标交付信息
    if (!actionBody.deliveryData || Object.keys(actionBody.deliveryData).length == 0) {
      return system.getResult(null, "交付数据不能为空，20135");
    }
    if (Number(actionBody.totalSum) < 300) {
      return system.getResult(null, "总价有误，总价不能小于300，20140");
    }
    var deliveryData = actionBody.deliveryData;
    if (!deliveryData.nclones) {
      return system.getResult(null, "商品/服务项不能为空，20150");
    }
    if (!deliveryData.tm) {
      return system.getResult(null, "商标信息不能为空，20180");
    }
    if (!deliveryData.tm.tmFormType) {
      return system.getResult(null, "商标类型不能为空，20183");
    }
    if (["3", "4", "5"].indexOf(deliveryData.tm.tmFormType) < 0) {
      return system.getResult(null, "商标类型值错误，20185");
    }
    if (deliveryData.tm.tmFormType == "4") {
      pobj.actionBody.deliveryData.tm.tmName = "图形";
      deliveryData.tm.tmName = "图形";
      pobj.actionBody.channelItemAppendName = "图形";
    }
    if (!deliveryData.tm.tmName) {
      return system.getResult(null, "商标名称不能为空，20180");
    }
    if (!deliveryData.tm.picUrl) {
      return system.getResult(null, "商标图样不能为空，20210");
    }
    if (!deliveryData.apply) {
      return system.getResult(null, "申请信息不能为空，20230");
    }
    if (!deliveryData.apply.code) {
      return system.getResult(null, "申请统一社会信用代码不能为空，20250");
    }
    if (!deliveryData.apply.zipCode) {
      return system.getResult(null, "申请邮编不能为空，20280");
    }
    if (!deliveryData.apply.customerType) {
      return system.getResult(null, "申请人类型不能为空，20310");
    }
    if (deliveryData.apply.customerType != "ent" && deliveryData.apply.customerType != "person") {
      return system.getResult(null, "申请人类型错误，20330");
    }
    var deliveryStatus = "dsccl";
    var deliveryStatusName = "待上传材料";
    var deliveryStatusList = [{
      deliveryStatus: "dsccl",
      deliveryStatusName: "待上传材料",
      deliveryUpdated: new Date()
    }];
    if (deliveryData.apply.customerType == "ent") {
      if (deliveryData.apply.businessLicensePdf && deliveryData.apply.gzwtsUrl) {
        deliveryStatus = "dsh";
        deliveryStatusName = "待审核";
        deliveryStatusList.push({
          deliveryStatus: deliveryStatus,
          deliveryStatusName: deliveryStatusName,
          deliveryUpdated: new Date()
        });
      }
    } else {
      if (deliveryData.apply.businessLicensePdf && deliveryData.apply.gzwtsUrl && deliveryData.apply.identityCardPdf) {
        deliveryStatus = "dsh";
        deliveryStatusName = "待审核";
        deliveryStatusList.push({
          deliveryStatus: deliveryStatus,
          deliveryStatusName: deliveryStatusName,
          deliveryUpdated: new Date()
        });
      }
    }
    actionBody.quantity = deliveryData.nclones.length;
    var price_item = actionBody.product_info.price_item;
    var self = this;
    var extraNclCount = 0;//计算多余的尼斯数量
    for (let index = 0; index < deliveryData.nclones.length; index++) {
      var nclThree = deliveryData.nclones[index].nclThree;
      deliveryData.nclones[index].nclCount = nclThree.length;
      deliveryData.nclones[index].nclPublicExpense = Number(price_item.public_expense);
      deliveryData.nclones[index].tmStatus = deliveryStatus;//商标交付状态
      deliveryData.nclones[index].tmStatusName = deliveryStatusName;
      deliveryData.nclones[index].submitTime = "";
      deliveryData.nclones[index].deliveryType = pobj.appInfo.delivery_type;//应用数据操作类型：00独立，10全委托
      deliveryData.nclones[index].tbCode = await self.getBusUid("tb" + pobj.appInfo.uapp_id);//提报号(自动生成)
      deliveryData.nclones[index].tmRegistNum = "";
      extraNclCount = extraNclCount + (nclThree.length - 10);
    }
    if (extraNclCount > 0) {
      if (!actionBody.additions) {
        return system.getResult(null, "附加购买项目不能为空，20335");
      }
      if (!actionBody.product_info.price_additions_item) {
        return system.getResult(null, "没有查询到附加购买项目信息，20336");
      }
      //重新计算尼斯官费
      for (let g = 0; g < deliveryData.nclones.length; g++) {
        const nclThree = deliveryData.nclones[g].nclThree;
        deliveryData.nclones[g].nclPublicExpense = Number(deliveryData.nclones[g].nclPublicExpense) + (nclThree.length - 10) * Number(actionBody.product_info.price_additions_item.public_expense);
      }
    }
    pobj.actionBody.deliveryData.deliveryStatus = deliveryStatus;
    pobj.actionBody.deliveryData.deliveryStatusName = deliveryStatusName;
    pobj.actionBody.deliveryData.deliveryStatusList = deliveryStatusList;
    pobj.actionBody.deliveryData.notes = actionBody.notes || ""; //  订单备注                                                                                                                                                                                               
    pobj.actionBody.deliveryData.opNotes = ""; //操作备注  
    return system.getResultSuccess();
  }

  //   caseService   拟开展服务项目  多 必
  // caseCustomerType   目标用户   多 必
  // caseProfitType    盈利模式   多 必
  // caseApprovalProgram  需专项审批的项目  多 
  // //caseApprovalProgramName  需专项审批的项目
  // //caseApprovalProgramUrl  需专项审批的项目文件
  // caseWeb 网站或APP情况  
  // caseWebName 网站或APP情况名称      必
  // caseApp 网站或APP情况
  // caseAppName 网站或APP情况名称
  // caseWebCertificateUrl  公司域名证书 必
  // caseTMCertificateUrl  公司商标证书  必


  // 必
  // apDxProgramType   申请的电信业务种类 默认
  // apProgramScope   申请的业务覆盖范围  默认
  // apCompany 公司名称  
  // apCompanyCode 企业统一社会信用代码
  // apCompanyRegCapital 注册资本
  // apCompanyRegAddr  注册地址
  // apCompanyTel  公司固定电话
  // apCompanyLicenseurl 企业法人营业执照
  // apCompanyWorkAddr  主要办公地址
  // apCompanyType  公司性质


  // 必
  // companyCate  公司目前主营业务所属行业
  // companyPersonnelNum 公司现有人员规模
  // companyBusinessScope  公司经营规模
  // companyLegalpersonName 法定代表人姓名
  // companyLpCertificateCode 法定代表人证件号
  // companyLpCertificateType 法定代表人证件类型
  // companyLpPhone 法定代表人手机
  // companyLpEmail 法定代表人邮箱
  // companyLpCertificateUrl  法定代表人身份证

  // companyLicenserName  许可负责人姓名
  // companyLoCertificateCode 许可负责人证件号
  // companyLoCertificateType 许可负责人证件类型
  // companyLoPhone 许可负责人手机
  // companyLoEmail 许可负责人邮箱
  // companyLoCertificateUrl  许可负责人身份证

  // companyCsName  客服负责人姓名
  // companyCsCertificateCode 客服负责人证件号
  // companyCsCertificateType 客服负责人证件类型
  // companyCsPhone 客服负责人手机
  // companyCsEmail 客服负责人邮箱
  // companyCsCertificateUrl  客服负责人身份证

  // companySafetyName  安全负责人姓名
  // companySfCertificateCode 安全负责人证件号
  // companySfCertificateType 安全负责人证件类型
  // companySfPhone 安全负责人手机
  // companySfEmail 安全负责人邮箱
  // companySfCertificateUrl  安全负责人身份证
  // shebaoCertificateUrl  社保证明




  // webSafetyOrginfo 网络与信息安全管理组织机构设置及工作职责  必
  // webSafetyPersonnel    网络与信息安全管理人员配备情况及其相应资质  必

  // shareholderCommitUrl 股东追溯不涉及外资承诺书    必
  // shareholderInfo 股东股权情况   多 必
  //  shareholderName  股东名称
  //  shareholderShareratio  股权比例
  // applicantInfo 申请者《国家企业《信用信息公示系统截图》   多 必

  // commitUrl 承诺书  必

  // otherCaseUrl  收费方案或其他
  // otherIDCCertificateUrl  托管协议及托管商IDC证书  多 必

  async createICPOrder(pobj) {

    // var packagingICPResult = await this.packagingICPDeliveryData(pobj, pobj.actionBody);
    // if (packagingICPResult.status != 0) {
    //   return packagingICPResult;
    // }
    var self = this;
    return await self.db.transaction(async function (t) {
      if (pobj.actionBody.orderNo) {
        self.putOrderDelivery(pobj.actionBody.deliveryData, pobj.actionBody.orderNo);
      } else {
        var orderNo = await self.getBusUid("icp" + pobj.appInfo.uapp_id);
        self.addOrderDelivery(pobj.actionBody.deliveryData, orderNo);
      }
      return system.getResultSuccess({
        orderNo: orderNo,
        channelServiceNo: pobj.actionBody.channelOrder.channelServiceNo || orderNo,
        channelOrderNo: pobj.actionBody.channelOrder.channelOrderNo || orderNo,
        channelParams: pobj.actionBody.channelOrder.channelParams || ""
      });
    });
  }

  async packagingICPDeliveryData(pobj, actionBody) {//重新组装商标交付信息
    if (actionBody.pageNum) {
      return "表单参数错误";
    }
    if (Number(actionBody.totalSum) < 300) {
      return "总价有误，总价不能小于300，20140";
    }
    var deliveryData = actionBody.deliveryData;
    if (!deliveryData.nclones) {
      return "商品/服务项不能为空，20150";
    }
    if (!deliveryData.tm) {
      return "商标信息不能为空，20180";
    }
    if (!deliveryData.tm.tmName) {
      return "商标名称不能为空，20180";
    }
    if (!deliveryData.tm.picUrl) {
      return "商标图样不能为空，20210";
    }
    if (!deliveryData.apply) {
      return "申请信息不能为空，20230";
    }
    if (!deliveryData.apply.code) {
      return "申请统一社会信用代码不能为空，20250";
    }
    if (!deliveryData.apply.zipCode) {
      return "申请邮编不能为空，20280";
    }
    if (!deliveryData.apply.customerType) {
      return "申请人类型不能为空，20310";
    }
    if (deliveryData.apply.customerType != "ent" && deliveryData.apply.customerType == "person") {
      return "申请人类型错误，20330";
    }
    var deliveryStatus = "dsccl";
    var deliveryStatusName = "待上传材料";
    if (deliveryData.apply.customerType == "ent") {
      if (deliveryData.apply.businessLicensePdf && deliveryData.apply.gzwtsUrl) {
        deliveryStatus = "dsh";
        deliveryStatusName = "待审核";
      }
    } else {
      if (deliveryData.apply.businessLicensePdf && deliveryData.apply.gzwtsUrl && deliveryData.apply.identityCardPdf) {
        deliveryStatus = "dsh";
        deliveryStatusName = "待审核";
      }
    }
    var price_item = actionBody.product_info.price_item;
    var self = this;
    var nclList = [];
    for (let index = 0; index < deliveryData.nclones.length; index++) {
      var nclones = deliveryData.nclones[index];
      var nclThree = nclones.nclThree;
      var tempNclones = {
        ncloneCode: nclones.code,
        ncloneName: nclones.name,
        nclThree: nclThree,
        nclCount: nclThree.length,
        nclPublicExpense: Number(price_item.price) * nclThree.length,
        deliveryStatus: deliveryStatus,//商标交付状态
        deliveryStatusName: deliveryStatusName,
        submitTime: "",
        deliveryType: pobj.appInfo.delivery_type,//应用数据操作类型：00独立，10全委托
        tbCode: await self.getBusUid("tb" + pobj.appInfo.uapp_id)//提报号(自动生成)
      }
      nclList.push(tempNclones);
    }
    pobj.actionBody.deliveryData.nclList = nclList;
    delete pobj.actionBody.deliveryData["nclones"];
    return system.getResultSuccess();
  }

  /**
   * 创建其他订单
   * @param {*} pobj  
   */
  async createOtherOrder(pobj) {
    var self = this;
    return await self.db.transaction(async function (t) {
      var orderNo = await self.getBusUid("ot" + pobj.appInfo.uapp_id);
      var item = await self.createOrder(pobj, orderNo, t);
      return system.getResultSuccess({
        orderNo: orderNo,
        channelServiceNo: pobj.actionBody.channelOrder.channelServiceNo || orderNo,
        channelOrderNo: pobj.actionBody.channelOrder.channelOrderNo || orderNo,
        channelParams: pobj.actionBody.channelOrder.channelParams || ""
      });
    });

  }

  async createChannelSource(pobj) {//创建渠道来源订单
    var orderNo = await self.getBusUid("oc" + pobj.appInfo.uapp_id);
    // var beforeOrder = await this.dao.model.findOne({
    //   where: { channelServiceNo: channelOrder.channelServiceNo, uapp_id: app.uAppId },
    //   raw: true
    // });
    // if (beforeOrder) {//订单已存在
    //   return system.getResultFail(2, "订单已存在", beforeOrder.orderNo);
    // }
  }

  //----------------------订单创建-----------end----------------------



  //=================================修改订单信息==============end======================================

  async updateContacts(pobj, actionBody) {//修改订单联系人
    var orderItem = await this.dao.getItemStatusByOrderNo(actionBody.orderNo, pobj.appInfo.uapp_id);
    if (!orderItem) {
      return system.getResult(null, "修改失败，修改的数据为空，30100");
    }
    if (orderItem.orderStatus == 4) {
      return system.getResult(null, "服务中的订单不能进行修改，30110");
    }
    if (orderItem.orderStatus == 8) {
      return system.getResult(null, "已完成的订单不能进行修改，30120");
    }
    if (!actionBody.orderContact) {
      return system.getResult(null, "联系人信息不能为空，30130");
    }
    if (!actionBody.orderContact.contacts) {
      return system.getResult(null, "联系人不能为空，30140");
    }
    if (!actionBody.orderContact.mobile) {
      return system.getResult(null, "手机号不能为空，30150");
    }
    var updateFields = {
      contactName: actionBody.orderContact.contacts || "",
      mobile: actionBody.orderContact.mobile,//手机号
      email: actionBody.orderContact.email || ""
    };
    this.ordercontactsDao.updateByWhere(updateFields, { where: { sourceOrderNo: actionBody.orderNo } });
    if (actionBody.notes) {
      actionBody.isGetContact = 0;
      var itemResult = await this.getOrderDeliveryInfo(pobj, actionBody);
      if (itemResult.status == 0) {
        if (actionBody.notes != itemResult.data.notes) {
          itemResult.data.notes = actionBody.notes;
          this.putOrderDelivery(itemResult.data, actionBody.orderNo);
        }
      }
    }//修改备注
    var resultParams = { orderStatus: orderItem.orderStatus };
    if (orderItem.orderStatus < 4) {
      var orderProductItem = await this.orderproductDao.getItemInfoByOrderNo(actionBody.orderNo);
      if (orderProductItem) {
        resultParams.product_info = JSON.parse(orderProductItem.serviceItemSnapshot);
      }
    }
    return system.getResultSuccess(resultParams);
  }
  async updateTmOrder(pobj, actionBody) {//修改商标订单信息
    var orderItem = await this.dao.getItemStatusByOrderNo(actionBody.orderNo, pobj.appInfo.uapp_id);
    if (!orderItem) {
      return system.getResult(null, "修改失败，修改的数据为空，30100");
    }
    var orderProductItem = await this.orderproductDao.getItemInfoByOrderNo(actionBody.orderNo);
    if (!orderProductItem) {
      return system.getResult(null, "修改失败，订单对应的产品数据为空，30105");
    }
    var product_info = JSON.parse(orderProductItem.serviceItemSnapshot);
    if (orderItem.orderStatus == 4) {
      return system.getResult(null, "服务中的订单不能进行修改，30110");
    }
    if (orderItem.orderStatus == 8) {
      return system.getResult(null, "已完成的订单不能进行修改，30120");
    }
    actionBody.isGetContact = 0;
    var itemResult = await this.getOrderDeliveryInfo(pobj, actionBody);
    if (itemResult.status != 0) {
      return itemResult;
    }
    if (!itemResult.data || Object.keys(itemResult.data).length == 0) {
      return system.getResult(null, "修改失败，修改的数据为空，30020");
    }
    var self = this;
    var tipsMsg = "";
    var apply = actionBody.apply;
    if (apply) {
      var dbApply = itemResult.data.apply;
      var applyKeys = Object.keys(apply);
      if (dbApply && applyKeys.length > 0) {
        for (let index = 0; index < applyKeys.length; index++) {
          const aKey = applyKeys[index];
          if (apply[aKey] != dbApply[aKey]) {
            itemResult.data.apply[aKey] = apply[aKey];
          }
        }
        var deliveryStatus = "dsccl";
        var deliveryStatusName = "待上传材料";
        if (itemResult.data.apply.customerType == "ent") {
          if (itemResult.data.apply.businessLicensePdf && itemResult.data.apply.gzwtsUrl) {
            deliveryStatus = "dsh";
            deliveryStatusName = "待审核";
          }
        } else {
          if (itemResult.data.apply.businessLicensePdf && itemResult.data.apply.gzwtsUrl && itemResult.data.apply.identityCardPdf) {
            deliveryStatus = "dsh";
            deliveryStatusName = "待审核";
          }
        }
        if (itemResult.data.deliveryStatus != deliveryStatus) {
          itemResult.data.deliveryStatus = deliveryStatus;
          itemResult.data.deliveryStatusName = deliveryStatusName;
          for (let j = 0; j < itemResult.data.nclones.length; j++) {
            itemResult.data.nclones[j].tmStatus = deliveryStatus;//商标交付状态
            itemResult.data.nclones[j].tmStatusName = deliveryStatusName;
          }
          var deliveryStatusList = itemResult.data.deliveryStatusList;
          if (deliveryStatusList && deliveryStatusList.length > 0) {
            var deliveryStatusIndex = deliveryStatusList.findIndex(f => f.deliveryStatus == deliveryStatus);
            if (deliveryStatusIndex < 0) {
              deliveryStatusList.push({
                deliveryStatus: deliveryStatus,
                deliveryStatusName: deliveryStatusName,
                deliveryUpdated: new Date()
              });
              itemResult.data.deliveryStatusList = deliveryStatusList;
            }
          }
        }
        //作为推送商标状态进行推送
        actionBody.deliveryStatus = deliveryStatus;
        actionBody.deliveryStatusName = deliveryStatusName;
      }
    }
    var tm = actionBody.tm;
    if (tm) {
      var dbTm = itemResult.data.tm;
      var tmKeys = Object.keys(tm);
      if (dbTm && tmKeys.length > 0) {
        for (let i = 0; i < tmKeys.length; i++) {
          const iKey = tmKeys[i];
          if (!tm[iKey]) {
            tipsMsg = "修改失败，" + iKey + "不能为空，30030";
          }
          if (tm[iKey] && tm[iKey] != dbTm[iKey]) {
            itemResult.data.tm[iKey] = tm[iKey].toString();
          }
        }
      }
      if (["3", "4", "5"].indexOf(tm.tmFormType.toString()) < 0) {
        return system.getResult(null, "商标类型值错误，20185");
      }
      var putOrderProductItem = {};
      if (tm.tmFormType.toString() == "4") {
        itemResult.data.tm.tmName = "图形";
        putOrderProductItem.channelItemAppendName = "图形";
      } else {
        if (tm.channelItemAppendName && tm.channelItemAppendName != orderProductItem.channelItemAppendName) {
          putOrderProductItem.channelItemAppendName = tm.channelItemAppendName;
        }
      }

      if (putOrderProductItem.channelItemAppendName) {
        self.orderproductDao.updateByWhere(putOrderProductItem, { where: { sourceOrderNo: actionBody.orderNo } });
      }
    }
    if (tipsMsg) {
      return system.getResult(null, tipsMsg);
    }
    var tempNclList = actionBody.nclones;
    if (tempNclList && tempNclList.length > 0) {
      var nclThreeCount = 0;
      var extraNclCount = 0;//计算多余的尼斯数量
      for (let h = 0; h < tempNclList.length; h++) {
        const nclThree = tempNclList[h].nclThree;
        tempNclList[h].nclCount = nclThree.length;
        tempNclList[h].nclPublicExpense = Number(product_info.price_item.public_expense);
        tempNclList[h].tmStatus = itemResult.data.deliveryStatus || "";//商标交付状态
        tempNclList[h].tmStatusName = itemResult.data.deliveryStatusName || "";
        tempNclList[h].submitTime = "";
        tempNclList[h].deliveryType = pobj.appInfo.delivery_type;//应用数据操作类型：00独立，10全委托
        tempNclList[h].tbCode = await self.getBusUid("tb" + pobj.appInfo.uapp_id);//提报号(自动生成)
        tempNclList[h].tmRegistNum = "";
        tempNclList[h].nclThree = nclThree;
        nclThreeCount = nclThreeCount + nclThree.length;
        extraNclCount = extraNclCount + (nclThree.length - 10);
      }
      if (extraNclCount > 0) {
        if (!actionBody.additions) {
          return system.getResult(null, "附加购买项目不能为空，20338");
        }
      }
      if (orderItem.orderStatus == 2) {
        var dbNclList = itemResult.data.nclones;
        if (dbNclList.length < tempNclList.length) {
          return system.getResult(null, "修改失败，尼斯大类应该为：" + dbNclList.length + "个大类，当前选择了" + tempNclList.length + "个大类，30040");
        }
        var dbNclThreeCount = 0;
        for (let k = 0; k < dbNclList.length; k++) {
          const kItem = dbNclList[k];
          dbNclThreeCount = dbNclThreeCount + Number(kItem.nclCount);
        }
        if (dbNclThreeCount < nclThreeCount) {
          var tempDbNclThreeCount = dbNclList.length * 10;
          if (tempDbNclThreeCount < nclThreeCount) {
            return system.getResult(null, "修改失败，尼斯应该为：" + dbNclThreeCount + "个小项，当前选择了" + nclThreeCount + "个小项，30050");
          }
        }
      }//已付款进行修改尼斯数据

      if (orderItem.orderStatus == 1) {
        actionBody.quantity = tempNclList.length;
        var isUpdateProduct = 0;
        var price_item = product_info.price_item;
        var price_additions_item = product_info.price_additions_item;
        var totalSum = Number(price_item.price) * Number(actionBody.quantity);
        var totalServiceCharge = Number(price_item.service_charge || 0) * Number(actionBody.quantity || 0);
        var totalPublicExpense = Number(price_item.public_expense || 0) * Number(actionBody.quantity || 0);
        var totalSupplyPrice = Number(price_item.supply_price || 0) * Number(actionBody.quantity || 0);//统计供货价格
        if (extraNclCount > 0) {
          if (!price_additions_item) {
            var additionsIndex = product_info.price_list.findIndex(f => f.pay_code == actionBody.additions.payCode && f.is_show == 0);
            if (additionsIndex >= 0) {
              isUpdateProduct++;
              price_additions_item = product_info.price_list[additionsIndex];
              product_info.price_additions_item = price_additions_item;
            }
          }
          totalSum = totalSum + Number(price_additions_item.price) * extraNclCount;
          totalServiceCharge = totalServiceCharge + Number(price_additions_item.service_charge || 0) * extraNclCount;
          totalPublicExpense = totalPublicExpense + Number(price_additions_item.public_expense || 0) * extraNclCount;
          totalSupplyPrice = totalSupplyPrice + Number(price_additions_item.supply_price || 0) * extraNclCount;//统计供货价格
          //重新计算尼斯官费
          for (let g = 0; g < tempNclList.length; g++) {
            const nclThree = tempNclList[g].nclThree;
            tempNclList[g].nclPublicExpense = Number(tempNclList[g].nclPublicExpense) + (nclThree.length - 10) * Number(price_additions_item.public_expense);
          }
        }
        else {
          if (price_additions_item) {
            isUpdateProduct++;
            delete product_info["price_additions_item"];
          }
        }
        var totalProfitSum = Number(totalSum) - Number(totalSupplyPrice || 0);//利润
        var pfProfitSum = (100 - Number(price_item.channel_profit_rate || 0)) / 100 * totalProfitSum;
        if (pfProfitSum < 0) {
          pfProfitSum = 0;
        }
        var channelProfitSum = Number(totalProfitSum) - Number(pfProfitSum);
        await self.db.transaction(async function (t) {
          if (Number(orderItem.totalSum) != totalSum) {
            var putOrderFields = {
              totalSum: totalSum,//decimal(12,2) //订单总额(产品价格×优惠费率×订单件数)                                                                                                                                           
              payTotalSum: totalSum,//decimal(12,2) //                                                                                                                                                                                                 
              refundSum: 0,//decimal(12,2) //退款总额
              totalServiceCharge: totalServiceCharge,//decimal(12,2) //服务费总额（产品配置的服务费*订单件数）                                                                                                                                       
              totalPublicExpense: totalPublicExpense,//decimal(12,2) //官费总额（产品配置的官费*订单件数）   
              totalProfitSum: totalProfitSum,//decimal(12,2) //订单毛利润总额（产品价格-供货价格））  
              pfProfitSum: pfProfitSum,//decimal(12,2) //订单平台毛利润总额（(100-渠道利润分成比例)/100 * 订单毛利润总额）                                                                                                         
              channelProfitSum: channelProfitSum//decimal(12,2) //订单渠道分成毛利润总额(订单毛利润总额-平台毛利润总额)  
            }
            self.updateByWhere(putOrderFields, { where: { orderNo: actionBody.orderNo } }, t);
            self.orderReceiptVoucherDao.updateByWhere({ totalSum: totalSum }, { where: { sourceOrderNo: actionBody.orderNo } }, t);
          }
          if (isUpdateProduct > 0) {
            self.orderproductDao.updateByWhere({ serviceItemSnapshot: JSON.stringify(product_info) }, { where: { sourceOrderNo: actionBody.orderNo } }, t);
          }
        });
      }//未付款进行订单金额修改
      itemResult.data.nclones = tempNclList;
      actionBody.nclones = tempNclList;
    }
    this.putOrderDelivery(itemResult.data, actionBody.orderNo);
    delete actionBody["isGetContact"];
    actionBody.orderStatus = orderItem.orderStatus;
    if (orderItem.orderStatus < 4) {
      actionBody.product_info = product_info;
    }
    return system.getResultSuccess(actionBody);
  }

  putOrderDelivery(data, orderNo) {//修改交付信息
    var sql = "UPDATE `c_order_delivery`  SET deliveryContent ='" + JSON.stringify(data) + "' where sourceOrderNo='" + orderNo + "'";
    this.customQuery(sql);
  }
  addOrderDelivery(data, orderNo) {//新增交付信息
    var sql = "INSERT INTO  `c_order_delivery` (`sourceOrderNo`,`deliveryContent`) VALUE('" +
      orderNo + "','" + JSON.stringify(data) + "')";
    this.customQuery(sql);
  }
  async delOrder(pobj, actionBody) {//删除订单
    await this.dao.delOrderByOrderNo(actionBody.orderNo, pobj.appInfo.uapp_id, pobj.userInfo.channel_userid);
    return system.getResultSuccess();
  }
  //=================================修改订单信息==============end======================================


  /**
   * 获取付款订单信息
   * @param {*} pobj 
   * @param {*} actionBody {orderNo:XXXX}
   */
  async getPayOrderInfo(pobj, actionBody) {
    var productItem = await this.orderproductDao.getItemByOrderNo(actionBody.orderNo, pobj.appInfo.uapp_id);
    if (!productItem) {
      return system.getResult(null, "订单产品数据异常，30090");
    }
    var item = await this.orderReceiptVoucherDao.getItemByOrderNo(actionBody.orderNo, pobj.appInfo.uapp_id);
    if (!item) {
      return system.getResult(null, "订单已经付款成功，请勿重复支付，30000");
    }
    var param = {
      receiptVoucher: item,
      orderProduct: productItem
    }
    return system.getResultSuccess(param);
  }
  /**
   * 修改订单收款信息
   * @param {*} pobj 
   * @param {*} actionBody {orderNo:XXXX,trxid:XXX--支付流水号,isPut:1---大于0则进行修改操作,setField:{XXXXX}---修改的字段,receiptVoucherId:XX--收款Id,opType:"wx"}---"wx":"微信","alipay":"支付宝"
   */
  async putReceiptVoucherInfo(pobj, actionBody) {
    var isPut = actionBody.isPut || "";
    if (isPut > 0) {
      await this.orderReceiptVoucherDao.updateByWhere(actionBody.setField, { where: { id: actionBody.receiptVoucherId } });
    }
    return system.getResultSuccess();
  }

  //**************************************获取订单信息**********start**************************************

  async getOrderInfo(pobj, actionBody) {//获取订单列表信息
    var pageSize = Number(actionBody.pageSize || 20);
    if (pageSize > 50) {
      pageSize = 50;
    }
    var pageIndex = Number(actionBody.pageIndex || 1);
    var from = pageIndex == 1 ? 0 : Number((pageIndex - 1) * pageSize);

    var paramWhere = {};
    var sql = "select `orderNo`,`channelServiceNo`,`channelOrderNo`,`channelUserId`,`ownerUserId`,`payTime`,`quantity`,`serviceQuantity`,`orderStatusName`,`orderStatus`,`totalSum`,`payTotalSum`,`refundSum`,"
      + " `invoiceApplyStatus`,`opNotes`,`channelItemCode`,`channelItemName`,`price`,priceDesc,priceTypeName,channelItemAppendName,`serviceItemCode`,`picUrl`,created_at from v_order where uapp_id=:uapp_id";
    var sqlCount = "select count(1) as dataCount from v_order where uapp_id=:uapp_id";

    paramWhere.uapp_id = pobj.appInfo.uapp_id;
    if (pobj.userInfo.channel_userid) {
      sql += " and channelUserId=:channelUserId";
      sqlCount += " and channelUserId=:channelUserId";
      paramWhere.channelUserId = pobj.userInfo.channel_userid;
    }
    if (actionBody.channelItemName) {
      sql += " and channelItemName like :channelItemName";
      sqlCount += " and channelItemName like :channelItemName";
      paramWhere.channelItemName = "%" + actionBody.channelItemName.trim() + "%";
    }
    if (actionBody.channelServiceNo) {
      sql += " and channelServiceNo like :channelServiceNo";
      sqlCount += " and channelServiceNo like :channelServiceNo";
      paramWhere.channelServiceNo = "%" + actionBody.channelServiceNo.trim() + "%";
    }
    if (actionBody.orderStatus) {
      sql += " and orderStatus=:orderStatus";
      sqlCount += " and orderStatus=:orderStatus";
      paramWhere.orderStatus = actionBody.orderStatus;
    }
    if (actionBody.startTime && actionBody.entTime) {
      var startTime = actionBody.startTime.trim() + " 00:00:00";
      var entTime = actionBody.entTime + " 23:59:59";
      sql += " and created_at >=:startTime and  created_at<=:entTime";
      sqlCount += " and created_at >=:startTime and  created_at<=:entTime";
      paramWhere.startTime = startTime;
      paramWhere.entTime = entTime;
    }

    sql += " order by id desc LIMIT " + pageSize + " OFFSET " + from;

    var list = await this.customQuery(sql, paramWhere);
    var result = system.getResultSuccess(list);

    var tmpResultCount = await this.customQuery(sqlCount, paramWhere);

    result.dataCount = tmpResultCount && tmpResultCount.length > 0 ? tmpResultCount[0].dataCount : 0;

    return result;

  }

  async getOrderDetails(pobj, actionBody) {//获取订单详情信息
    var sql = "select `orderNo`,`channelServiceNo`,`channelOrderNo`,`channelUserId`,`ownerUserId`,`payTime`,`quantity`,`serviceQuantity`,`orderStatusName`,`orderStatus`,`totalSum`,`payTotalSum`,`refundSum`," +
      " `invoiceApplyStatus`,`opNotes`,`channelItemCode`,`channelItemName`,`price`,priceDesc,priceTypeName,channelItemAppendName,`serviceItemCode`,`picUrl`,created_at from " +
      " v_order where uapp_id=:uapp_id and orderNo=:orderNo  LIMIT 1";
    var paramWhere = { uapp_id: pobj.appInfo.uapp_id, orderNo: actionBody.orderNo };
    var list = await this.customQuery(sql, paramWhere);
    if (!list || list.length == 0) {
      return system.getResult(null, "订单数据为空，30200");
    }
    var result = system.getResultSuccess(list[0]);
    return result;
  }
  async getOrderDeliveryInfo(pobj, actionBody) {//获取订单交付信息
    var sql = "select * from c_order_delivery where sourceOrderNo=:sourceOrderNo";
    var paramWhere = { sourceOrderNo: actionBody.orderNo };
    var list = await this.customQuery(sql, paramWhere);
    var result = system.getResultSuccess();
    result.data = {};
    if (list && list.length > 0) {
      if (list[0].deliveryContent) {
        result.data = list[0].deliveryContent;
      }
    }
    result.data.orderContact = null;
    if (!actionBody.isGetContact) {
      var item = await this.ordercontactsDao.getItemByOrderNo(actionBody.orderNo);
      if (item) {
        result.data.orderContact = item;
      }
    }//是否获取联系人，isGetContact有值则不获取
    return result;
  }
  async getOrderDeliveryFlowInfo(pobj, actionBody) {//获取订单交付流程信息
    var sql = "select * from c_delivery_official_flow where sourceOrderNo=:sourceOrderNo";
    var paramWhere = { sourceOrderNo: actionBody.sourceOrderNo };
    var list = await this.customQuery(sql, paramWhere);
    var result = system.getResultSuccess();
    if (list && list.length > 0) {
      if (list[0].officialFlow) {
        result.data = list[0].officialFlow;
      }
    }
    return result;
  }
  async getOrderDeliveryFlowList(pobj, actionBody) {//获取订单交付流程列表信息
    var sql = "select * from c_delivery_official_flow where sourceOrderNo IN(:sourceOrderNo)";
    var paramWhere = { sourceOrderNo: actionBody.sourceOrderNoList };
    var list = await this.customQuery(sql, paramWhere);
    var tmpList = [];
    if (list && list.length > 0) {
      for (let index = 0; index < list.length; index++) {
        const element = list[index];
        if (element.officialFlow) {
          tmpList.push({
            sourceOrderNo: element.sourceOrderNo,
            flowList: element.officialFlow
          });
        }
      }
    }
    return system.getResultSuccess(tmpList);
  }
  async getOrderLogInfo(pobj, actionBody) {//获取订单日志信息
    var list = await this.flowlogDao.getlogListBySourceOrderNo(actionBody.sourceOrderNo);
    return system.getResultSuccess(list);
  }

  //**************************************/获取订单信息**********end**************************************

  //-------------------------------服务商通知订单流程-------------start----------------
  async icOrderStatusNotify(pobj, actionBody) {//峰擎通知工商办理状态
    var item = await this.dao.getItemStatusByOrderNo(actionBody.orderNo);
    if (!item) {
      return system.getResult(null, "order data is empty!");
    }
    if (item.orderStatus == 1) {
      return system.getResult(null, "order status is unpay!");
    }
    var updateDeliveryInfo = {
      orderDeliveryStatus: actionBody.orderDeliveryStatus,
      orderDeliveryStatusName: actionBody.orderDeliveryStatusName,
      updated: actionBody.updated,
      flowList: []
    };
    pobj.actionBody.sourceOrderNo = actionBody.orderNo;
    var deliveryInfo = await this.getOrderDeliveryFlowInfo(pobj);
    var addi = 0;
    if (deliveryInfo.status == 0 && deliveryInfo.data && deliveryInfo.data.flowList.length > 0) {
      updateDeliveryInfo.flowList = deliveryInfo.data.flowList;
    } else {
      updateDeliveryInfo = {
        orderDeliveryStatus: "已下单",
        orderDeliveryStatusName: "已下单",
        updated: item.created_at,
        flowList: [{
          orderDeliveryStatus: "已下单",
          orderDeliveryStatusName: "已下单",
          updated: item.created_at
        }]
      };
      addi = 1;
    }
    updateDeliveryInfo.updated = actionBody.updated;
    updateDeliveryInfo.orderDeliveryStatus = actionBody.orderDeliveryStatus;
    var tempList = actionBody.orderDeliveryStatusName.split('-');
    updateDeliveryInfo.orderDeliveryStatusName = tempList[tempList.length - 1];

    var dataIndex = updateDeliveryInfo.flowList.findIndex(f => f.orderDeliveryStatus == actionBody.orderDeliveryStatus);
    if (dataIndex > -1) {
      updateDeliveryInfo.flowList[dataIndex].orderDeliveryStatusName = actionBody.orderDeliveryStatusName;
      updateDeliveryInfo.flowList[dataIndex].updated = actionBody.updated;
    } else {
      updateDeliveryInfo.flowList.push({
        orderDeliveryStatus: actionBody.orderDeliveryStatus,
        orderDeliveryStatusName: actionBody.orderDeliveryStatusName,
        updated: actionBody.updated
      });
    }
    var orderLog = {
      uapp_id: item.uapp_id,
      sourceOrderNo: actionBody.orderNo,
      created_at: actionBody.updated,
      opContent: "您的订单办理流程更新为【" + updateDeliveryInfo.orderDeliveryStatusName + "】",
      isShow: 1
    };
    await this.flowlogDao.create(orderLog);
    var sql = null;
    if (addi > 0) {
      await this.dao.updateByWhere({ orderStatus: 4 }, { where: { id: item.id } });
      sql = "INSERT INTO  `c_delivery_official_flow` (`sourceOrderNo`,`officialFlow`) VALUE('" +
        actionBody.orderNo + "','" + JSON.stringify(updateDeliveryInfo) + "')";
    }
    else {
      if (updateDeliveryInfo.orderDeliveryStatusName == "证件邮寄环节") {
        await this.dao.updateByWhere({ orderStatus: 8 }, { where: { id: item.id } });
      }
      sql = "UPDATE `c_delivery_official_flow`  SET officialFlow ='" + JSON.stringify(updateDeliveryInfo) + "' where sourceOrderNo='" + actionBody.orderNo + "'";
    }
    this.customQuery(sql);
    return system.getResultSuccess();
  }

  async updateTmStatus(actionBody) {
    var self = this;
    if (!actionBody.tbCode) {
      return system.getResult(null, "处理失败，tbCode不能为空，30160");
    }
    if (!actionBody.tmStatus) {
      return system.getResult(null, "处理失败，tmStatus不能为空，30163");
    }
    if (!actionBody.tmStatusName) {
      return system.getResult(null, "处理失败，tmStatusName不能为空，30165");
    }
    var orderItem = await this.dao.getItemStatusByOrderNo(actionBody.orderNo);
    if (!orderItem) {
      return system.getResult(null, "修改失败，修改的数据为空，30170");
    }
    if (orderItem.orderStatus == 1) {
      return system.getResult(null, "修改失败，修改的订单数据未未付款数据为空，30175");
    }
    actionBody.orderContact = 1;
    var deliveryInfoResult = await this.getOrderDeliveryInfo(null, actionBody);
    if (deliveryInfoResult.status != 0 || !deliveryInfoResult.data) {
      return system.getResult(null, "修改失败，订单对应的产品数据为空，30180");
    }
    var deliveryInfo = deliveryInfoResult.data;
    var tbCodeIndex = deliveryInfo.nclones.findIndex(f => f.tbCode == actionBody.tbCode);
    if (tbCodeIndex < 0) {
      return system.getResult(null, "修改失败，订单对应的提报数据为空，30185");
    }
    deliveryInfo.nclones[tbCodeIndex].tmStatus = actionBody.tmStatus;
    deliveryInfo.nclones[tbCodeIndex].tmStatusName = actionBody.tmStatusName;
    var updateOrderFields = {};
    var orderLog = {
      uapp_id: orderItem.uapp_id,
      sourceOrderNo: actionBody.orderNo,
      created_at: new Date(),
      opContent: "尊敬的用户，您的商标：“" + deliveryInfo.tm.tmName + "”第" + deliveryInfo.nclones[tbCodeIndex].code + "类，办理状态更新为【" + actionBody.tmStatusName + "】",
      isShow: 1
    };
    var oldDeliveryStatus = deliveryInfo.deliveryStatus;
    if (actionBody.tmStatus == "WAITCOMMIT") {
      updateOrderFields.orderStatus = 4;
      deliveryInfo.deliveryStatus = "ddj";
      deliveryInfo.deliveryStatusName = "待递交";
      deliveryInfo.nclones[tbCodeIndex].tmStatus = "ddj";
      deliveryInfo.nclones[tbCodeIndex].tmStatusName = "待递交";
      orderLog.opContent = "尊敬的用户，您的商标：“" + deliveryInfo.tm.tmName + "”第" + deliveryInfo.nclones[tbCodeIndex].code + "类，办理状态更新为【待递交】";
    }//待提交
    else if (actionBody.tmStatus == "ROBOT") {
      deliveryInfo.deliveryStatus = "ydj";
      deliveryInfo.deliveryStatusName = "已递交";
      deliveryInfo.nclones[tbCodeIndex].tmStatus = "ydj";
      deliveryInfo.nclones[tbCodeIndex].tmStatusName = "已递交";
      orderLog.opContent = "尊敬的用户，您的商标：“" + deliveryInfo.tm.tmName + "”第" + deliveryInfo.nclones[tbCodeIndex].code + "类，办理状态更新为【已递交】";
    }//已提交
    else if (actionBody.tmStatus == "RECVCOMMIT") {
      updateOrderFields.orderStatus = 8;
      deliveryInfo.deliveryStatus = "ywc";
      deliveryInfo.deliveryStatusName = "已完成";
      deliveryInfo.nclones[tbCodeIndex].tmStatusName = "商标局已收提交";
      orderLog.opContent = "尊敬的用户，您的商标：“" + deliveryInfo.tm.tmName + "”第" + deliveryInfo.nclones[tbCodeIndex].code + "类，办理状态更新为【商标局已收提交】";
    }//已收提交

    if (deliveryInfo.deliveryStatus != oldDeliveryStatus) {
      var deliveryStatusList = deliveryInfo.deliveryStatusList;
      if (deliveryStatusList && deliveryStatusList.length > 0) {
        var deliveryStatusIndex = deliveryStatusList.findIndex(f => f.deliveryStatus == deliveryInfo.deliveryStatus);
        if (deliveryStatusIndex < 0) {
          deliveryStatusList.push({
            deliveryStatus: deliveryInfo.deliveryStatus,
            deliveryStatusName: deliveryInfo.deliveryStatusName,
            deliveryUpdated: new Date()
          });
          deliveryInfo.deliveryStatusList = deliveryStatusList;
        }
      }
    }//增加流程状态列表数据

    try {
      await self.db.transaction(async function (t) {
        if (Object.keys(updateOrderFields).length > 0) {
          self.updateByWhere(updateOrderFields, { where: { orderNo: actionBody.orderNo } }, t);
        }
        await self.flowlogDao.create(orderLog, t);
      });
      if (actionBody.submitTime) {
        deliveryInfo.nclones[tbCodeIndex].submitTime = actionBody.submitTime;
      }//修改提报时间
      if (actionBody.registNumInfo && actionBody.registNumInfo.tmRegistNum) {
        deliveryInfo.nclones[tbCodeIndex].tmRegistNum = actionBody.registNumInfo.tmRegistNum;
      }//更新商标申请号
      if (actionBody.officialInfo) {
        this.updateTmOfficialInfo(actionBody);
      }//更新商标官文
      deliveryInfo.opNotes = actionBody.opNotes || "";
      this.putOrderDelivery(deliveryInfo, actionBody.orderNo);


    } catch (error) {
      console.log("error------------------------", e.stack);
    }
    return system.getResultSuccess();
  }

  async updateTmOfficialInfo(actionBody) {//更新商标官文信息
    var flowList = [];
    actionBody.sourceOrderNo = actionBody.officialInfo.tmRegistNum;
    var deliveryFlowInfo = await this.getOrderDeliveryFlowInfo(null, actionBody);
    var addi = 0;
    if (!deliveryFlowInfo.data) {
      flowList.push({
        updated: actionBody.officialInfo.updated,
        uploadFileName: actionBody.officialInfo.uploadFileName,
        returnReceiptUrl: actionBody.officialInfo.returnReceiptUrl,
        tmStatus: actionBody.tmStatus,
        tmStatusName: actionBody.tmStatusName
      });
      addi++;
    }
    else {
      flowList = deliveryFlowInfo.data;
    }
    var dataIndex = flowList.findIndex(f => f.tmStatus == actionBody.tmStatus);
    if (dataIndex < 0) {
      flowList.push({
        updated: actionBody.officialInfo.updated,
        uploadFileName: actionBody.officialInfo.uploadFileName,
        returnReceiptUrl: actionBody.officialInfo.returnReceiptUrl,
        tmStatus: actionBody.tmStatus,
        tmStatusName: actionBody.tmStatusName
      });
    }
    var sql = null;
    if (addi > 0) {
      sql = "INSERT INTO  `c_delivery_official_flow` (`sourceOrderNo`,`officialFlow`) VALUE('" +
        actionBody.officialInfo.tmRegistNum + "','" + JSON.stringify(flowList) + "')";
    }
    else {
      sql = "UPDATE `c_delivery_official_flow`  SET officialFlow ='" + JSON.stringify(flowList) + "' where sourceOrderNo='" + actionBody.officialInfo.tmRegistNum + "'";
    }
    this.customQuery(sql);
    return system.getResultSuccess();
  }

  async opOrderPayCallBackTl(parmas, appInfo) {//操作订单付款回调---通联
    var item = await this.dao.getItemStatusByOrderNo(parmas.orderNo)
    if (!item) {
      return system.getResult(null, "order data is empty!");
    }
    if (item.orderStatus > 1) {
      return system.getResult(null, "order status is pay!");
    }
    var self = this;
    await self.db.transaction(async function (t) {
      await self.dao.updateByWhere({ orderStatus: 2, payTime: new Date() }, { where: { orderNo: parmas.orderNo } }, t);
      var putFields = {
        auditStatus: "tg",
        accountType: parmas.pay_type,
        passTradeNo: parmas.trxid || "",//通道的统一订单号
        payOrderNo: parmas.chnltrxid || "",//支付凭证流水单号，如：微信支付凭证单号
        busPayOrderCode: parmas.out_trade_no || "",//业务支付订单号
        buyerOpenId: parmas.openid || "",//用户在支付商户appid下的唯一标识或买家在支付宝的用户id    
        buyerAliLogonId: parmas.buyer_logon_id || "",//买家支付宝账号
        notes: parmas.paytime || ""//备注下支付时间
      };
      await self.orderReceiptVoucherDao.updateByWhere(putFields, { where: { sourceOrderNo: parmas.orderNo } }, t);
      var orderLog = {
        uapp_id: appInfo.uapp_id,
        sourceOrderNo: parmas.orderNo,
        opContent: "您成功支付了订单，请等待服务商服务",
        isShow: 1
      };
      await self.flowlogDao.create(orderLog, t);
      var moneyObj = {
        uapp_id: appInfo.uapp_id,
        sourceOrderNo: parmas.orderNo,   // 来源单号
        channelUserId: item.channelUserId,
        ownerUserId: item.ownerUserId,
        accountType: parmas.pay_type,//帐户类型（ 支付类型）:"cash": "现金", "bank": "银行" ,"wx":"微信","alipay":"支付宝","other":"其它"
        directionType: "sr",//凭单类型,"sr": "收","zc": "支"
        voucherDate: new Date(),//凭单时间
        recvAmount: item.totalSum,//收总额
        sourceType: "orderinfo",//来源类型 "orderinfo": "订单","expensevoucher": "费用单"
        auditStatus: "tg",//审核状态"dsh": "待审核", "btg": "不通过", "tg": "通过"
      };
      var moneyJourney = await self.moneyJourneyDao.create(moneyObj, t);
    });

    var resultParams = {
      order_info: item,
      delivery_content: null,//包含订单联系人orderContact
      product_info: null
    };
    var deliveryInfoResult = await this.getOrderDeliveryInfo(null, parmas);
    if (deliveryInfoResult && deliveryInfoResult.status == 0) {
      resultParams.delivery_content = deliveryInfoResult.data;
    }
    var orderProductItem = await this.orderproductDao.getItemInfoByOrderNo(parmas.orderNo);
    if (orderProductItem) {
      resultParams.product_info = JSON.parse(orderProductItem.serviceItemSnapshot);
    }
    return system.getResultSuccess(resultParams);
  }

  //-------------------------------服务商通知订单流程-------------end----------------

}
module.exports = OrderInfoService;